<template>
  <v-card color="white" height="100%" width="100%">
    <v-form ref="form" v-model="formValid" @submit.prevent="">
      <template v-if="withSectionsAsTabs && !loading">
        <v-card-title>
          <h2 class="font-weight-bold form-title">
            {{ title }}
          </h2>
        </v-card-title>
        <v-tabs v-model="tabs" slider-size="3">
          <v-tab v-for="(section, id) in mySchema" :key="id">
            {{ section.sectionTitle.title }}
          </v-tab>
        </v-tabs>
        <v-tabs-items v-model="tabs">
          <v-tab-item v-for="(section, id) in mySchema" :key="id" eager>
            <v-card-text>
              <CustomFormBase
                :model="myModel[id].schema"
                :schema="section.schema"
              />
            </v-card-text>
          </v-tab-item>
        </v-tabs-items>
        <v-card-actions class="pa-5 mt-auto">
          <v-spacer></v-spacer>

          <v-btn
            class="mr-4 white--text"
            color="yellow darken-2"
            :loading="loading"
            :disabled="isFirstTab"
            @click="previousTab()"
          >
            {{ $t('forms.back') }}
          </v-btn>
          <v-btn
            class="mr-4"
            color="primary"
            :loading="loading"
            :disabled="isLastTab"
            @click="nextTab()"
          >
            {{ $t('forms.next') }}
          </v-btn>
          <v-btn
            class="mr-4 white--text"
            color="green darken-2"
            :loading="loading"
            :disabled="!formValid"
            type="submit"
            @click="submit()"
          >
            {{ $t('forms.enviar') }}
          </v-btn>
          <v-btn
            class="mr-4 white--text"
            :loading="loading"
            color="purple darken-2"
            @click="validate"
          >
            Validate
          </v-btn>
        </v-card-actions>
      </template>
      <template v-if="!withSectionsAsTabs && !loading">
        <v-card-title>
          <h2 class="font-weight-bold form-title">
            {{ title }}
          </h2>
        </v-card-title>
        <v-card-text>
          <CustomFormBase :model="myModel" :schema="mySchema" />
        </v-card-text>
        <v-card-actions class="pa-5 mt-auto">
          <v-spacer></v-spacer>
          <v-btn
            class="mr-4"
            color="primary"
            :loading="loading"
            :disabled="!formValid"
            type="submit"
            @click="submit()"
          >
            {{ $t('forms.enviar') }}
          </v-btn>
        </v-card-actions>
      </template>
    </v-form>
  </v-card>
</template>

<script>
import { cloneDeep, merge } from 'lodash'
import CustomFormBase from '@/components/forms/FormBase/CustomFormBase.vue'

export default {
  components: {
    CustomFormBase,
  },
  props: {
    formId: { type: String, default: '' },
    userId: { type: String, default: '' },
    disabled: { type: Boolean, default: false },
  },
  data() {
    return {
      loading: false,
      formValid: false,
      title: null,
      list: [],
      myModel: {},
      mySchema: {},
      tabs: null,
      withSectionsAsTabs: null,
    }
  },
  async fetch() {
    this.loading = true
    const schemaLocal = {}
    const modelLocal = {}
    const self = this
    let id = null
    if (this.formId !== '') {
      id = self.formId
    } else {
      id = this.$route.params.formid
    }
    await this.$fire.firestore
      .collection(`forms`)
      .doc(id)
      .get()
      .then((doc) => {
        const { title, items, sections, withSections, withSectionsAsTabs } =
          doc.data()
        self.title = title
        if (!withSections) {
          self.mySchema = this.reduceList(items)
          // await Promise.all(
          //   items.map(async (question) => {
          //     if (question.defaultAnswer) {
          //       await self.insertDefaultAnswer(
          //         question,
          //         modelLocal,
          //         withSections
          //       )
          //     }
          //   })
          // )
          items.forEach((question) =>
            self.insertDefaultAnswer(question, modelLocal, withSections)
          )

          self.myModel = modelLocal
        } else {
          sections.forEach(
            (section) => {
              const questions = items.filter(function (value) {
                return value.section === section.id
              })
              const schema = self.reduceList(questions, section.multipleAnswers)
              let groupQuestions
              if (section.multipleAnswers) {
                groupQuestions = {
                  sectionTitle: {
                    title: section.name,
                    type: 'sectionTitle',
                    col: { cols: 12 },
                  },
                  add: {
                    type: 'btn',
                    iconCenter: 'mdi-plus',
                    label: 'Añadir',
                    dark: true,
                    class: 'mb-2',
                    color: 'blue lighten-2',
                  },
                  spacer: { type: 'spacer', col: { sm: 12 } },
                  answers: {
                    type: 'array',
                    schema,
                  },
                }
                modelLocal[section.id] = { answers: [{}] }
              } else {
                groupQuestions = {
                  sectionTitle: {
                    title: section.name,
                    type: 'sectionTitle',
                    col: { cols: 12 },
                  },
                  schema,
                }
              }
              schemaLocal[section.id] = groupQuestions

              // Colocamos las respuestas por default
              questions.forEach((question) => {
                if (question.defaultAnswer) {
                  self.insertDefaultAnswer(question, modelLocal, withSections)
                }
              })

              if (!modelLocal[section.id]) {
                modelLocal[section.id] = { schema: {} }
              }
            }

            // await Promise.all(
            //   questions.map(async (question) => {
            //     if (question.defaultAnswer) {
            //       await self.insertDefaultAnswer(
            //         question,
            //         modelLocal,
            //         withSections
            //       )
            //     }
            //   })
            // )
          )
          self.myModel = modelLocal
          self.mySchema = schemaLocal
          self.withSectionsAsTabs = withSectionsAsTabs
        }
      })
    this.loading = false
  },
  computed: {
    isLastTab() {
      const numSections = Object.keys(this.mySchema).length
      return this.tabs >= numSections - 1
    },
    isFirstTab() {
      return this.tabs === 0
    },
  },

  watch: {
    myModel() {
      // this.validate()
    },
  },
  async mounted() {
    // await this.validate()
  },

  methods: {
    nextTab() {
      if (this.tabs !== null) {
        this.tabs = this.tabs + 1
      }
    },
    previousTab() {
      if (this.tabs !== null) {
        this.tabs = this.tabs - 1
      }
    },
    async validate() {
      //   // if
      await this.$nextTick()
      this.$refs.form.validate()
      //   // console.log(this.$refs[ref])
      //   // this.$refs[ref].validate()
    },
    insertDefaultAnswer(question, model, withSections) {
      if (withSections === true) {
        if (!([question.section] in model)) {
          Object.assign(model, { [question.section]: { schema: {} } })
          model[question.section].schema[question.id] =
            this.$store.state.users.user[question.defAnsw]
        } else {
          model[question.section].schema[question.id] =
            this.$store.state.users.user[question.defAnsw]
        }
      } else {
        Object.assign(model, {
          [question.id]: this.$store.state.users.user[question.defAnsw],
        })
      }
      // await this.$fire.firestore
      //   .collection(`users`)
      //   .doc(this.$store.state.users.user.dni)
      //   .get()
      //   .then((doc) => {
      //     if (withSections === true) {
      //       if (!([question.section] in model)) {
      //         Object.assign(model, { [question.section]: { schema: {} } })
      //         model[question.section].schema[question.id] =
      //           doc.data()[question.defAnsw]
      //       } else {
      //         model[question.section].schema[question.id] =
      //           doc.data()[question.defAnsw]
      //       }
      //     } else {
      //       Object.assign(model, {
      //         [question.id]: doc.data()[question.defAnsw],
      //       })
      //     }
      //   })
    },
    reduceList(list, withMultiple) {
      const self = this
      const schema = list.reduce(function (acc, curr, index) {
        switch (curr.kind) {
          case 'paragraph':
            curr.type = 'textarea'
            curr.col = { cols: 12, sm: 10, md: 6 }
            curr.singleLine = true
            curr.outlined = true
            break
          case 'radio':
            curr.type = 'radio'
            curr.col = { cols: 12, sm: 10, md: 6 }
            curr.singleLine = true
            curr.outlined = true
            break
          case 'checkbox':
            curr.type = 'select'
            curr.multiple = true
            curr.items = curr.options
            curr.col = { cols: 12, sm: 10, md: 6 }
            curr.singleLine = true
            curr.outlined = true
            break
          case 'dropdown':
            curr.type = 'select'
            curr.items = curr.options
            curr.col = { cols: 12, sm: 10, md: 6 }
            curr.singleLine = true
            curr.outlined = true
            break
          case 'date':
            curr.type = 'date'
            curr.ext = 'text'
            curr.col = { cols: 12, sm: 10, md: 6 }
            curr.singleLine = true
            curr.outlined = true
            curr.text = {
              label: curr.label,
              appendIcon: 'mdi-calendar',
            }
            break
          case 'time':
            curr.type = 'time'
            curr.ext = 'text'
            curr.col = { cols: 12, sm: 10, md: 6 }
            curr.singleLine = true
            curr.outlined = true
            curr.text = {
              label: curr.label,
              appendIcon: 'mdi-clock',
            }
            break
          case 'file':
            curr.type = 'file'
            curr.col = { cols: 12, sm: 10, md: 6 }
            curr.singleLine = true
            curr.outlined = true
            break
          default:
            curr.type = 'text'
            curr.col = { cols: 12, sm: 10, md: 6 }
            curr.singleLine = true
            curr.outlined = true
            break
        }
        if (self.disabled) {
          curr.disabled = true
        }
        if (curr.required)
          curr.rules = [(v) => !!v || 'El campo es obligatorio']
        acc[curr.id] = curr

        if (curr.spacer)
          acc['spacer' + index] = { type: 'spacer', col: { sm: 6 } }
        return acc
      }, {})
      if (withMultiple) {
        schema.remove = {
          type: 'btn',
          iconCenter: 'mdi-delete',
          label: 'Eliminar',
          dark: true,
          class: 'mb-2',
          color: 'blue lighten-2',
        }
      }
      return schema
    },
    async asyncForEach(array, callback) {
      for (let index = 0; index < array.length; index++) {
        await callback(array[index], index, array)
      }
    },
    async upload(files) {
      const uploadedFiles = []
      const storageRef = this.$fire.storage.ref()
      let id = null
      if (this.formId !== '') {
        id = this.formId
      } else {
        id = this.$route.params.formid
      }
      await this.asyncForEach(files, async (element) => {
        const [key, file] = Object.entries(element)[0]
        await storageRef
          .child(
            // `${this.$route.params.id}/${id}/${Date.now()}.${file.name
            //   .split('.')
            //   .pop()}`
            `formsFiles/${id}/${Date.now()}.${file.name.split('.').pop()}`
          )
          .put(file)
          .then(async (snapshot) => {
            await snapshot.ref.getDownloadURL().then((downloadURL) => {
              uploadedFiles.push({
                [key]: downloadURL,
              })
            })
          })
      })
      return uploadedFiles
    },
    async submit() {
      let id = null
      if (this.formId !== '') {
        id = this.formId
      } else {
        id = this.$route.params.formid
      }
      this.loading = true
      const files = []
      Object.entries(this.myModel).forEach((element) => {
        if (element[1].type) {
          files.push({
            [element[0]]: element[1],
          })
        }
      })
      const uploadedFiles = await this.upload(files)
      const uploadedPaths = uploadedFiles.reduce((acc, curr) => {
        const [key, value] = Object.entries(curr)[0]
        acc[key] = value
        return acc
      }, {})
      const data = cloneDeep(this.myModel)
      merge(data, uploadedPaths)
      data.createdAt = new Date()

      try {
        await this.$fire.firestore
          .collection(`forms/${id}/answers`)
          .doc()
          .set({ ...data })
        this.loading = false
        this.$store.dispatch('notifications/open', {
          color: 'success',
          text: 'Enviado con éxito',
        })
        this.$refs.form.reset()
      } catch (error) {
        this.loading = false
        this.$store.dispatch('notifications/open', {
          color: 'error',
          text: error.message,
        })
      }
    },
    addAnswer(section, slot) {
      this.myModel[section][slot].push({})
    },
    removeAnswer(section, index) {
      this.myModel[section].answers.splice(index, 1)
    },
  },
}
</script>

<style>
.form-title {
  font-size: 1.8em;
  color: #2a3042;
}
@media screen and (max-width: 600px) {
  .type-form-base-spacer {
    display: none;
  }
}
.v-input--radio-group__input > legend {
  display: none;
}
</style>
